#
#                      Yeppp! library implementation
#
# This file is part of Yeppp! library and licensed under 2-clause BSD license.
# See library/LICENSE.txt for details.
#
#

library(matlab);

dyn.load('yerrr.so')

L <- 1024 * 1024 * 64;
A <- rnorm(L);
Am <- as.matrix(A);
B <- rnorm(L);

tic(); invisible(I <- .Call("yerCore_DotProduct_V64fV64f_S64f", A, B)); toc();
tic(); invisible(J <- crossprod(A, B)); toc(); 

tic(); invisible(X <- .Call("yerCore_Add_V64fV64f_V64f", A, B)); toc();
tic(); invisible(Y <- A + B); toc();

tic(); invisible(X <- .Call("yerMath_Log_V64f_V64f", A)); toc();
tic(); invisible(X <- log(A)); toc();

tic(); invisible(X <- .Call("yerCore_SumSquares_V64f_S64f", A)); toc();
tic(); invisible(X <- crossprod(A, A)); toc();
tic(); invisible(X <- norm(Am, type = "F")); toc();

dyn.unload('yerrr.so')
