/*
 *                      Yeppp! library implementation
 *                  This file is auto-generated by Peach-Py,
 *       Portable Efficient Assembly Code-generator in Higher-level Python,
 *                   part of the Yeppp! library infrastrure
 *
 * This file is part of Yeppp! library and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

package info.yeppp;

/** @brief	Vector mathematical functions. */
public class Math {
	static {
		System.loadLibrary("yeppp");
		System.loadLibrary("yeppp-jni");
	}

	/** @name	Natural Logarithm */
	/**@{*/
	public static native void Log_V64f_V64f(double[] numberArray, int numberOffset, double[] logNumberArray, int logNumberOffset, int length);
	/**@}*/


	/** @name	Base-e Exponent */
	/**@{*/
	/**
	 * @brief	Computes vector exponent of double-precision (64-bit) floating-point elements in the input array, producing an array of double-precision (64-bit) floating-point elements in the output array.
	 * @param[in]	xArray	Input array of double-precision (64-bit) floating-point elements to compute exponent on.
	 * @param[in]   xOffset Offset of the first element in @a xArray to be used as input.
	 * @param[out]	yArray	Pointer the output array of double-precision (64-bit) floating-point elements to store the exponent values.
	 * @param[in]   yOffset Offset of the first element in @a yArray to be used as output.
	 * @param[in]	length	The length of the subarrays to be used in computation.
	 * @throws	NullPointerException	If @a xArray or @a yArray argument is null.
	 * @throws	InvalidArgumentException	If the @a xOffset or @a yOffset argument is negative.
	 * @throws	NegativeArraySizeException	If the @a length argument is null.
	 * @throws  IndexOutOfBoundsException If @a xOffset + @a length exceeds the length of @a xArray array or @a yOffset + @a length exceeds the length of @a yArray array.
	 * @throws	MisalignedPointerError	If one of the arrays is not properly aligned.
	 */
	public static native void Exp_V64f_V64f(double[] xArray, int xOffset, double[] yArray, int yOffset, int length);
	/**@}*/


}
