/*
 *                      Yeppp! library implementation
 *                  This file is auto-generated by Peach-Py,
 *       Portable Efficient Assembly Code-generator in Higher-level Python,
 *                   part of the Yeppp! library infrastrure
 *
 * This file is part of Yeppp! library and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

#include <jni.h>
#include <yepCore.h>


JNIEXPORT void JNICALL Java_info_yeppp_Core_MultiplyAdd_1V32fV32fV32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jfloatArray zArray, jint zOffset, jfloatArray macArray, jint macOffset, jint length) {
	enum YepStatus status;
	jfloat* xPointer = NULL;
	jfloat* yPointer = NULL;
	jfloat* zPointer = NULL;
	jfloat* macPointer = NULL;

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	zPointer = (*env)->GetPrimitiveArrayCritical(env, zArray, NULL);
	macPointer = (*env)->GetPrimitiveArrayCritical(env, macArray, NULL);

	status = yepCore_MultiplyAdd_V32fV32fV32f_V32f(&xPointer[xOffset], &yPointer[yOffset], &zPointer[zOffset], &macPointer[macOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, zArray, zPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, macArray, macPointer, 0);
}

JNIEXPORT void JNICALL Java_info_yeppp_Core_MultiplyAdd_1V64fV64fV64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jdoubleArray zArray, jint zOffset, jdoubleArray macArray, jint macOffset, jint length) {
	enum YepStatus status;
	jdouble* xPointer = NULL;
	jdouble* yPointer = NULL;
	jdouble* zPointer = NULL;
	jdouble* macPointer = NULL;

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	zPointer = (*env)->GetPrimitiveArrayCritical(env, zArray, NULL);
	macPointer = (*env)->GetPrimitiveArrayCritical(env, macArray, NULL);

	status = yepCore_MultiplyAdd_V64fV64fV64f_V64f(&xPointer[xOffset], &yPointer[yOffset], &zPointer[zOffset], &macPointer[macOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, zArray, zPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, macArray, macPointer, 0);
}

JNIEXPORT void JNICALL Java_info_yeppp_Core_MultiplyAdd_1V32fS32fIV32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloat y, jint yOffset, jfloatArray zArray, jint zOffset, jint length) {
	enum YepStatus status;
	jfloat* xPointer = NULL;
	jfloat* zPointer = NULL;

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	zPointer = (*env)->GetPrimitiveArrayCritical(env, zArray, NULL);

	status = yepCore_MultiplyAdd_V32fS32fIV32f_IV32f(&xPointer[xOffset], &y, &zPointer[zOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, zArray, zPointer, 0);
}

JNIEXPORT void JNICALL Java_info_yeppp_Core_MultiplyAdd_1V64fS64fIV64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdouble y, jint yOffset, jdoubleArray zArray, jint zOffset, jint length) {
	enum YepStatus status;
	jdouble* xPointer = NULL;
	jdouble* zPointer = NULL;

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	zPointer = (*env)->GetPrimitiveArrayCritical(env, zArray, NULL);

	status = yepCore_MultiplyAdd_V64fS64fIV64f_IV64f(&xPointer[xOffset], &y, &zPointer[zOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, zArray, zPointer, 0);
}
