/*
 *                      Yeppp! library build framework
 *
 * This file is part of Yeppp! library infrastructure and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

package info.yeppp.Build;

import java.util.Collection;
import java.util.List;

public interface Librarian {
	public BuildMessages createStaticLibrary(String libraryPath, Collection<String> objectPaths);

	public void setBinariesDirectory(String binariesDirectory);

	public String getBinariesDirectory();

	public void setObjectDirectory(String objectDirectory);

	public String getObjectDirectory();

	public boolean addLibraryDependence(String libraryName);

	public boolean removeLibraryDependence(String libraryName);

	public void clearLibraryDependences();

	public void addDefaultGlobalLibraryDirectories();

	public boolean addGlobalLibraryDirectory(String libraryDirectory);

	public boolean removeGlobalLibraryDirectory(String libraryDirectory);

	public void clearGlobalLibraryDirectories();

	public boolean addLibraryDirectory(String libraryDirectory);

	public boolean removeLibraryDirectory(String libraryDirectory);

	public void clearLibraryDirectories();
}
