/*
 *                      Yeppp! library implementation
 *                  This file is auto-generated by Peach-Py,
 *       Portable Efficient Assembly Code-generator in Higher-level Python,
 *                   part of the Yeppp! library infrastrure
 *
 * This file is part of Yeppp! library and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

#include <yepPredefines.h>
#include <yepTypes.h>
#include <yepPrivate.hpp>
#include <core/DotProduct.disp.h>

#if defined(YEP_MICROSOFT_COMPILER) || defined(YEP_INTEL_COMPILER_FOR_WINDOWS)
	#pragma section(".rdata$DispatchTable", read)
	#pragma section(".data$FunctionPointer", read, write)
#endif

extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V32fV32f_S32f_Default(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length);
#if defined(YEP_X86_CPU)
#endif // YEP_X86_CPU
#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V32fV32f_S32f_Nehalem(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V32fV32f_S32f_SandyBridge(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V32fV32f_S32f_Bulldozer(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V32fV32f_S32f_Nehalem(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V32fV32f_S32f_SandyBridge(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V32fV32f_S32f_Bulldozer(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
YEP_USE_CONST_SECTION(DispatchTable) const FunctionDescriptor<YepStatus (YEPABI*)(const Yep32f* YEP_RESTRICT, const Yep32f* YEP_RESTRICT, Yep32f* YEP_RESTRICT, YepSize)> _dispatchTable_yepCore_DotProduct_V32fV32f_S32f[] = 
{
	#if defined(YEP_X86_CPU)
	#endif // YEP_X86_CPU
	#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V32fV32f_S32f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE3, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V32fV32f_S32f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V32fV32f_S32f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
	#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V32fV32f_S32f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE3, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V32fV32f_S32f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V32fV32f_S32f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
	#if defined(YEP_IA64_CPU)
	#endif // YEP_IA64_CPU
	#if defined(YEP_ARM_CPU)
	#endif // YEP_ARM_CPU
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V32fV32f_S32f_Default, YepIsaFeaturesDefault, YepSimdFeaturesDefault, YepSystemFeaturesDefault, YepCpuMicroarchitectureUnknown, "c++", "Naive", "None")
};

extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_Default(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
#if defined(YEP_X86_CPU)
#endif // YEP_X86_CPU
#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_Nehalem(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_SandyBridge(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_Bulldozer(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_Bonnell(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_Nehalem(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_SandyBridge(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_Bulldozer(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_DotProduct_V64fV64f_S64f_Bonnell(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
YEP_USE_CONST_SECTION(DispatchTable) const FunctionDescriptor<YepStatus (YEPABI*)(const Yep64f* YEP_RESTRICT, const Yep64f* YEP_RESTRICT, Yep64f* YEP_RESTRICT, YepSize)> _dispatchTable_yepCore_DotProduct_V64fV64f_S64f[] = 
{
	#if defined(YEP_X86_CPU)
	#endif // YEP_X86_CPU
	#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE3 | YepX86SimdFeatureSSE2, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_Bonnell, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE2, YepX86SystemFeatureSSE, YepCpuMicroarchitectureBonnell, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
	#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE3 | YepX86SimdFeatureSSE2, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_Bonnell, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE2, YepX86SystemFeatureSSE, YepCpuMicroarchitectureBonnell, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
	#if defined(YEP_IA64_CPU)
	#endif // YEP_IA64_CPU
	#if defined(YEP_ARM_CPU)
	#endif // YEP_ARM_CPU
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_DotProduct_V64fV64f_S64f_Default, YepIsaFeaturesDefault, YepSimdFeaturesDefault, YepSystemFeaturesDefault, YepCpuMicroarchitectureUnknown, "c++", "Naive", "None")
};


YEP_USE_DATA_SECTION(FunctionPointer) YepStatus (YEPABI*_yepCore_DotProduct_V32fV32f_S32f)(const Yep32f* YEP_RESTRICT, const Yep32f* YEP_RESTRICT, Yep32f* YEP_RESTRICT, YepSize) = YEP_NULL_POINTER;
YEP_USE_DATA_SECTION(FunctionPointer) YepStatus (YEPABI*_yepCore_DotProduct_V64fV64f_S64f)(const Yep64f* YEP_RESTRICT, const Yep64f* YEP_RESTRICT, Yep64f* YEP_RESTRICT, YepSize) = YEP_NULL_POINTER;

#if defined(YEP_MICROSOFT_COMPILER) || defined(YEP_INTEL_COMPILER_FOR_WINDOWS)
	#pragma code_seg( push, ".text$DispatchFunction" )
#endif

YEP_USE_CODE_SECTION(DispatchFunction) YepStatus YEPABI yepCore_DotProduct_V32fV32f_S32f(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT dotProductPointer, YepSize length) {
	return _yepCore_DotProduct_V32fV32f_S32f(xPointer, yPointer, dotProductPointer, length);
}

YEP_USE_CODE_SECTION(DispatchFunction) YepStatus YEPABI yepCore_DotProduct_V64fV64f_S64f(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT dotProductPointer, YepSize length) {
	return _yepCore_DotProduct_V64fV64f_S64f(xPointer, yPointer, dotProductPointer, length);
}

#if defined(YEP_MICROSOFT_COMPILER) || defined(YEP_INTEL_COMPILER_FOR_WINDOWS)
	#pragma code_seg( pop )
#endif
